//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    MomPeriod  = 14;
extern int    MomMaMode  = MODE_LWMA;
extern int    MomPrice   = 0;
extern double upperLevel = 0.001;
extern double lowerLevel = -0.001;
//
//
//
//
//

double UpH[];
double DnH[]; 
double NuH[];
double mom[];
double prc[];   
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(6); 
   SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);   
   SetIndexBuffer(2,NuH); SetIndexStyle(2,DRAW_HISTOGRAM);  
   SetIndexBuffer(3,mom);
   SetIndexBuffer(4,prc);
   SetIndexBuffer(5,trend);
   if (StringSubstr(Symbol(),3,3)=="JPY") { upperLevel=upperLevel*100; lowerLevel=lowerLevel*100; }
   IndicatorShortName("Momentum Histo");   
return(0);
}

//
//
//
//
//

int deinit() {   return(0);}

//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 

   //
   //
   //
   //
   //
   
   
   for (i=limit; i>=0; i--)
   { 
      prc[i] = iMA(NULL,0,1,0,MomMaMode,MomPrice,i);
      mom[i] = prc[i]-prc[i+MomPeriod];
      
      //
      //
      //
      //
      //
      
      UpH[i] = EMPTY_VALUE;
      DnH[i] = EMPTY_VALUE;
      NuH[i] = EMPTY_VALUE;
      trend[i] = 0;
         if (mom[i]>upperLevel)                      trend[i] = 1;
         if (mom[i]<lowerLevel)                      trend[i] =-1;
         if (mom[i]<upperLevel && mom[i]>lowerLevel) trend[i] = 0; 
         if (trend[i] == 1) UpH[i] = 1;
         if (trend[i] ==-1) DnH[i] = 1;
         if (trend[i] == 0) NuH[i] = 1;    
   }
return(0);
}
     
     